extern   string   Str1           = "   MQL4";
extern   string   Str2           = "   !!!";
extern   string   Str3           = "   ! ;)";
extern   int      TextSize       = 24;
extern   string   TextFont       = "Times New Roman";
extern   color    TextColor      = LimeGreen;

extern   bool     SnowflakeFalls = True;
extern   int      SnowflakeCode  = 172;
extern   int      SnowflakeWidth = 0;
extern   color    SnowflakeColor = White;

extern   int      SleepTime      = 10;

int      i, numberSnowflakes;
double   Step;

string   Name;
int      Bar;
double   Price;
bool     CanMove;

int      FirstBar, BarsChrt;
double   PriceMax, PriceMin;

int init()
{
   ObjectCreate("Str1", OBJ_TEXT, 0, 0, 0, 0, 0, 0, 0);
   ObjectSetText("Str1", Str1, TextSize, TextFont, TextColor);
   ObjectCreate("Str2", OBJ_TEXT, 0, 0, 0, 0, 0, 0, 0);
   ObjectSetText("Str2", Str2, TextSize, TextFont, TextColor);
   ObjectCreate("Str3", OBJ_TEXT, 0, 0, 0, 0, 0, 0, 0);
   ObjectSetText("Str3", Str3, TextSize, TextFont, TextColor);
   
   Step = Point;
   if (Digits == 3 || Digits == 5)
      Step *= 10;
   
   MathSrand(TimeLocal());
   start();
}

int start()
{
   while (True)
   {
      FirstBar = WindowFirstVisibleBar();
      BarsChrt = WindowBarsPerChart();
      PriceMax = WindowPriceMax();
      PriceMin = WindowPriceMin();
      Bar      = FirstBar-BarsChrt/2;
      Price    = (PriceMax-PriceMin)/10;
      
      ObjectSet("Str1", OBJPROP_TIME1, Time[Bar]);
      ObjectSet("Str1", OBJPROP_PRICE1, PriceMax-Price);
      ObjectSet("Str2", OBJPROP_TIME1, Time[Bar]);
      ObjectSet("Str2", OBJPROP_PRICE1, PriceMax-Price*2);
      ObjectSet("Str3", OBJPROP_TIME1, Time[Bar]);
      ObjectSet("Str3", OBJPROP_PRICE1, PriceMax-Price*3);
      
      for (i = 0; i < numberSnowflakes; i++)
      {
         Name = StringConcatenate("Snowflake", i);
         Price = ObjectGet(Name, OBJPROP_PRICE1);
         Bar = iBarShift(NULL, 0, ObjectGet(Name, OBJPROP_TIME1));
         CanMove = False;
         if (SnowflakeFalls)
         {
            if (Price > High[Bar]+Step)
               CanMove = True;
         }
         else
            CanMove = True;
         if (Price <= Step)
            CanMove = False;
         if (CanMove)
            ObjectSet(Name, OBJPROP_PRICE1, Price-Step);
      }
      newSnowflake();
      WindowRedraw();
      if (SleepTime > 0)
         Sleep(SleepTime);
   }
}

void newSnowflake()
{
   Name = StringConcatenate("Snowflake", numberSnowflakes);
   numberSnowflakes++;
   ObjectCreate(Name, OBJ_ARROW, 0, 0, 0, 0, 0, 0, 0);
   ObjectSet(Name, OBJPROP_ARROWCODE, SnowflakeCode);
   ObjectSet(Name, OBJPROP_STYLE, DRAW_ARROW);
   ObjectSet(Name, OBJPROP_TIME1, Time[FirstBar-(MathRand()+1)/(32768/BarsChrt)]);
   ObjectSet(Name, OBJPROP_PRICE1, PriceMax);
   ObjectSet(Name, OBJPROP_WIDTH, SnowflakeWidth);
   ObjectSet(Name, OBJPROP_COLOR, SnowflakeColor);
}